package org.runetracker;

import java.awt.Toolkit;
import java.awt.TrayIcon;

public class TrayIconController {
	private boolean inError;

	private boolean busy;

	private boolean informationMissing;

	private final TrayIcon icon;

	public TrayIconController(final TrayIcon icon) {
		this.icon = icon;

		stateChanged();
	}

	public boolean isBusy() {
		return busy;
	}

	public boolean isInError() {
		return inError;
	}

	public boolean isInformationMissing() {
		return informationMissing;
	}

	public void setBusy(boolean busy) {
		this.busy = busy;
		stateChanged();
	}

	public void setInError(boolean inError) {
		this.inError = inError;
		stateChanged();
	}

	public void setInformationMissing(boolean informationMissing) {
		this.informationMissing = informationMissing;
		stateChanged();
	}

	protected void stateChanged() {
		if (!busy && !inError && !informationMissing)
			icon.setImage(Toolkit.getDefaultToolkit().createImage(TrayIconController.class.getClassLoader().getResource("images/runetracker-updater-ready.png")));
		else if (busy)
			icon.setImage(Toolkit.getDefaultToolkit().createImage(TrayIconController.class.getClassLoader().getResource("images/runetracker-updater-busy.png")));
		else if (informationMissing)
			icon.setImage(Toolkit.getDefaultToolkit().createImage(TrayIconController.class.getClassLoader().getResource("images/runetracker-updater-information-missing.png")));
		else if (inError)
			icon.setImage(Toolkit.getDefaultToolkit().createImage(TrayIconController.class.getClassLoader().getResource("images/runetracker-updater-error.png")));
	}
}
